
/* JLO2SNA.C   (c) 01/1996 Alvin Albrecht (sealbrec@acs.ucalgary.ca)

   Converts NMI state save taken by JLO disk interface into a .SNA
   snapshot.  Input file must have name "in.jlo" and output file
   will have name "out.sna".  Care must be taken when converting a
   TS2068 specific snapshot to .sna form as information is lost in
   the conversion.  Only programs that make use of the advanced video
   modes or bankswitching may be affected.

   To keep up net standards, please only convert jlo saves to .sna
   from Spectrum mode.

*/

#include <stdio.h>

#define char unsigned char

typedef struct
{
   char i,hlpl,hlph,depl,deph,bcpl,bcph;
   char afpl,afph,hll,hlh,del,deh,bcl,bch;
   char iyl,iyh,ixl,ixh,ie,r,afl,afh,spl,sph;
   char im,bc;
} HEADER;    /* The 27 byte .SNA header */

main()
{
   FILE *jlo,*sna;
   long i;
   int inch;
   HEADER head;

   jlo=fopen("in.jlo","rb");
   sna=fopen("out.sna","wb");

   for (i=0x3e00; i<=0x3ee8; i++)
      fscanf(jlo,"%c",&inch);
   head.ie=inch&0x4;

   fscanf(jlo,"%c",&head.i);
   fscanf(jlo,"%c%c",&head.iyl,&head.iyh);
   fscanf(jlo,"%c%c",&head.ixl,&head.ixh);
   fscanf(jlo,"%c%c",&head.bcpl,&head.bcph);
   fscanf(jlo,"%c%c",&head.depl,&head.deph);
   fscanf(jlo,"%c%c",&head.afpl,&head.afph);
   fscanf(jlo,"%c%c",&head.afl,&head.afh);
   fscanf(jlo,"%c%c",&head.bcl,&head.bch);
   fscanf(jlo,"%c%c",&head.del,&head.deh);
   fscanf(jlo,"%c%c",&head.hll,&head.hlh);
   fscanf(jlo,"%c%c",&head.hlpl,&head.hlph);
   fscanf(jlo,"%c%c",&head.spl,&head.sph);

   for (i=0x3f00; i<=0x3f0e; i++)
      fscanf(jlo,"%c",&inch);
   head.im=((inch) ? (2):(1));

   fscanf(jlo,"%c",&head.r);

   i=head.sph*256+head.spl+2;
   head.sph=(i&0xff00)>>8; head.spl=i&0xff;
   head.bc=0;

   for (i=0x3f10; i<0x4000; i++)
      fscanf(jlo,"%c",&inch);

   for (i=0; i<27; i++)
      fprintf(sna,"%c",((char *)(&head))[i]);

   while ((inch=fgetc(jlo))!=EOF)
      fprintf(sna,"%c",inch);

   fclose(jlo);
   fclose(sna);
}

